Commit | Line | Data |
---|---|---|
08785f48 | 1 | #!/bin/sh |
ecbed728 | 2 | # Enable automatic program execution by the kernel. |
08785f48 | 3 | |
bfe69cc8 | 4 | qemu_target_list="i386 i486 alpha arm armeb sparc32plus ppc ppc64 ppc64le m68k \ |
3bef0451 | 5 | mips mipsel mipsn32 mipsn32el mips64 mips64el \ |
ecbed728 RH |
6 | sh4 sh4eb s390x aarch64 aarch64_be hppa riscv32 riscv64 xtensa xtensaeb \ |
7 | microblaze microblazeel or1k" | |
3bef0451 LV |
8 | |
9 | i386_magic='\x7fELF\x01\x01\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\x03\x00' | |
daf238dc | 10 | i386_mask='\xff\xff\xff\xff\xff\xfe\xfe\x00\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff\xff' |
3bef0451 LV |
11 | i386_family=i386 |
12 | ||
13 | i486_magic='\x7fELF\x01\x01\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\x06\x00' | |
daf238dc | 14 | i486_mask='\xff\xff\xff\xff\xff\xfe\xfe\x00\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff\xff' |
3bef0451 LV |
15 | i486_family=i386 |
16 | ||
17 | alpha_magic='\x7fELF\x02\x01\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\x26\x90' | |
daf238dc | 18 | alpha_mask='\xff\xff\xff\xff\xff\xfe\xfe\x00\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff\xff' |
3bef0451 LV |
19 | alpha_family=alpha |
20 | ||
21 | arm_magic='\x7fELF\x01\x01\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\x28\x00' | |
22 | arm_mask='\xff\xff\xff\xff\xff\xff\xff\x00\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff\xff' | |
23 | arm_family=arm | |
24 | ||
25 | armeb_magic='\x7fELF\x01\x02\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\x28' | |
26 | armeb_mask='\xff\xff\xff\xff\xff\xff\xff\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff' | |
2ced93ee | 27 | armeb_family=armeb |
3bef0451 LV |
28 | |
29 | sparc_magic='\x7fELF\x01\x02\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\x02' | |
daf238dc | 30 | sparc_mask='\xff\xff\xff\xff\xff\xff\xff\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff' |
3bef0451 LV |
31 | sparc_family=sparc |
32 | ||
33 | sparc32plus_magic='\x7fELF\x01\x02\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\x12' | |
daf238dc | 34 | sparc32plus_mask='\xff\xff\xff\xff\xff\xff\xff\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff' |
3bef0451 LV |
35 | sparc32plus_family=sparc |
36 | ||
37 | ppc_magic='\x7fELF\x01\x02\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\x14' | |
38 | ppc_mask='\xff\xff\xff\xff\xff\xff\xff\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff' | |
39 | ppc_family=ppc | |
40 | ||
41 | ppc64_magic='\x7fELF\x02\x02\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\x15' | |
42 | ppc64_mask='\xff\xff\xff\xff\xff\xff\xff\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff' | |
43 | ppc64_family=ppc | |
44 | ||
45 | ppc64le_magic='\x7fELF\x02\x01\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\x15\x00' | |
46 | ppc64le_mask='\xff\xff\xff\xff\xff\xff\xff\x00\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff\x00' | |
47 | ppc64le_family=ppcle | |
48 | ||
49 | m68k_magic='\x7fELF\x01\x02\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\x04' | |
daf238dc | 50 | m68k_mask='\xff\xff\xff\xff\xff\xff\xfe\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff' |
3bef0451 LV |
51 | m68k_family=m68k |
52 | ||
53 | # FIXME: We could use the other endianness on a MIPS host. | |
54 | ||
55 | mips_magic='\x7fELF\x01\x02\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\x08' | |
56 | mips_mask='\xff\xff\xff\xff\xff\xff\xff\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff' | |
57 | mips_family=mips | |
58 | ||
59 | mipsel_magic='\x7fELF\x01\x01\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\x08\x00' | |
60 | mipsel_mask='\xff\xff\xff\xff\xff\xff\xff\x00\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff\xff' | |
61 | mipsel_family=mips | |
62 | ||
63 | mipsn32_magic='\x7fELF\x01\x02\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\x08' | |
64 | mipsn32_mask='\xff\xff\xff\xff\xff\xff\xff\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff' | |
65 | mipsn32_family=mips | |
66 | ||
67 | mipsn32el_magic='\x7fELF\x01\x01\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\x08\x00' | |
68 | mipsn32el_mask='\xff\xff\xff\xff\xff\xff\xff\x00\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff\xff' | |
69 | mipsn32el_family=mips | |
70 | ||
71 | mips64_magic='\x7fELF\x02\x02\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\x08' | |
72 | mips64_mask='\xff\xff\xff\xff\xff\xff\xff\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff' | |
73 | mips64_family=mips | |
74 | ||
75 | mips64el_magic='\x7fELF\x02\x01\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\x08\x00' | |
76 | mips64el_mask='\xff\xff\xff\xff\xff\xff\xff\x00\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff\xff' | |
77 | mips64el_family=mips | |
78 | ||
79 | sh4_magic='\x7fELF\x01\x01\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\x2a\x00' | |
daf238dc | 80 | sh4_mask='\xff\xff\xff\xff\xff\xff\xff\x00\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff\xff' |
3bef0451 LV |
81 | sh4_family=sh4 |
82 | ||
83 | sh4eb_magic='\x7fELF\x01\x02\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\x2a' | |
daf238dc | 84 | sh4eb_mask='\xff\xff\xff\xff\xff\xff\xff\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff' |
3bef0451 LV |
85 | sh4eb_family=sh4 |
86 | ||
87 | s390x_magic='\x7fELF\x02\x02\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\x16' | |
daf238dc | 88 | s390x_mask='\xff\xff\xff\xff\xff\xff\xff\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff' |
3bef0451 LV |
89 | s390x_family=s390x |
90 | ||
91 | aarch64_magic='\x7fELF\x02\x01\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\xb7\x00' | |
92 | aarch64_mask='\xff\xff\xff\xff\xff\xff\xff\x00\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff\xff' | |
93 | aarch64_family=arm | |
94 | ||
f772f212 MW |
95 | aarch64_be_magic='\x7fELF\x02\x02\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\xb7' |
96 | aarch64_be_mask='\xff\xff\xff\xff\xff\xff\xff\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff' | |
2ced93ee | 97 | aarch64_be_family=armeb |
f772f212 | 98 | |
e4d966cc LV |
99 | hppa_magic='\x7f\x45\x4c\x46\x01\x02\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\x0f' |
100 | hppa_mask='\xff\xff\xff\xff\xff\xff\xff\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff' | |
101 | hppa_family=hppa | |
102 | ||
25fa194b MC |
103 | riscv32_magic='\x7fELF\x01\x01\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\xf3\x00' |
104 | riscv32_mask='\xff\xff\xff\xff\xff\xff\xff\x00\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff\xff' | |
105 | riscv32_family=riscv | |
106 | ||
107 | riscv64_magic='\x7fELF\x02\x01\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\xf3\x00' | |
108 | riscv64_mask='\xff\xff\xff\xff\xff\xff\xff\x00\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff\xff' | |
109 | riscv64_family=riscv | |
110 | ||
d4090306 MF |
111 | xtensa_magic='\x7fELF\x01\x01\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\x5e\x00' |
112 | xtensa_mask='\xff\xff\xff\xff\xff\xff\xff\x00\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff\xff' | |
113 | xtensa_family=xtensa | |
114 | ||
115 | xtensaeb_magic='\x7fELF\x01\x02\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\x5e' | |
116 | xtensaeb_mask='\xff\xff\xff\xff\xff\xff\xff\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff' | |
117 | xtensaeb_family=xtensaeb | |
118 | ||
947aeab3 LV |
119 | microblaze_magic='\x7fELF\x01\x02\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\xba\xab' |
120 | microblaze_mask='\xff\xff\xff\xff\xff\xff\xff\x00\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff\xff' | |
121 | microblaze_family=microblaze | |
122 | ||
123 | microblazeel_magic='\x7fELF\x01\x01\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\xab\xba' | |
124 | microblazeel_mask='\xff\xff\xff\xff\xff\xff\xff\x00\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff\xff' | |
125 | microblazeel_family=microblazeel | |
126 | ||
ecbed728 RH |
127 | or1k_magic='\x7fELF\x01\x02\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\x5c' |
128 | or1k_mask='\xff\xff\xff\xff\xff\xff\xff\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff' | |
129 | or1k_family=or1k | |
130 | ||
3bef0451 LV |
131 | qemu_get_family() { |
132 | cpu=${HOST_ARCH:-$(uname -m)} | |
133 | case "$cpu" in | |
134 | amd64|i386|i486|i586|i686|i86pc|BePC|x86_64) | |
135 | echo "i386" | |
136 | ;; | |
137 | mips*) | |
138 | echo "mips" | |
139 | ;; | |
140 | "Power Macintosh"|ppc64|powerpc|ppc) | |
141 | echo "ppc" | |
142 | ;; | |
143 | ppc64el|ppc64le) | |
144 | echo "ppcle" | |
145 | ;; | |
2ced93ee | 146 | arm|armel|armhf|arm64|armv[4-9]*l|aarch64) |
3bef0451 LV |
147 | echo "arm" |
148 | ;; | |
2ced93ee MW |
149 | armeb|armv[4-9]*b|aarch64_be) |
150 | echo "armeb" | |
151 | ;; | |
3bef0451 LV |
152 | sparc*) |
153 | echo "sparc" | |
154 | ;; | |
25fa194b MC |
155 | riscv*) |
156 | echo "riscv" | |
157 | ;; | |
3bef0451 LV |
158 | *) |
159 | echo "$cpu" | |
160 | ;; | |
161 | esac | |
162 | } | |
163 | ||
164 | usage() { | |
165 | cat <<EOF | |
166 | Usage: qemu-binfmt-conf.sh [--qemu-path PATH][--debian][--systemd CPU] | |
167 | [--help][--credential yes|no][--exportdir PATH] | |
7155be7c | 168 | [--persistent yes|no][--qemu-suffix SUFFIX] |
3bef0451 LV |
169 | |
170 | Configure binfmt_misc to use qemu interpreter | |
171 | ||
7155be7c LV |
172 | --help: display this usage |
173 | --qemu-path: set path to qemu interpreter ($QEMU_PATH) | |
174 | --qemu-suffix: add a suffix to the default interpreter name | |
175 | --debian: don't write into /proc, | |
176 | instead generate update-binfmts templates | |
177 | --systemd: don't write into /proc, | |
178 | instead generate file for systemd-binfmt.service | |
179 | for the given CPU. If CPU is "ALL", generate a | |
180 | file for all known cpus | |
181 | --exportdir: define where to write configuration files | |
182 | (default: $SYSTEMDDIR or $DEBIANDIR) | |
183 | --credential: if yes, credential and security tokens are | |
184 | calculated according to the binary to interpret | |
185 | --persistent: if yes, the interpreter is loaded when binfmt is | |
186 | configured and remains in memory. All future uses | |
187 | are cloned from the open file. | |
3bef0451 LV |
188 | |
189 | To import templates with update-binfmts, use : | |
190 | ||
191 | sudo update-binfmts --importdir ${EXPORTDIR:-$DEBIANDIR} --import qemu-CPU | |
192 | ||
193 | To remove interpreter, use : | |
194 | ||
195 | sudo update-binfmts --package qemu-CPU --remove qemu-CPU $QEMU_PATH | |
196 | ||
197 | With systemd, binfmt files are loaded by systemd-binfmt.service | |
198 | ||
199 | The environment variable HOST_ARCH allows to override 'uname' to generate | |
200 | configuration files for a different architecture than the current one. | |
201 | ||
202 | where CPU is one of: | |
203 | ||
204 | $qemu_target_list | |
205 | ||
206 | EOF | |
207 | } | |
208 | ||
209 | qemu_check_access() { | |
210 | if [ ! -w "$1" ] ; then | |
211 | echo "ERROR: cannot write to $1" 1>&2 | |
212 | exit 1 | |
213 | fi | |
214 | } | |
215 | ||
216 | qemu_check_bintfmt_misc() { | |
217 | # load the binfmt_misc module | |
218 | if [ ! -d /proc/sys/fs/binfmt_misc ]; then | |
219 | if ! /sbin/modprobe binfmt_misc ; then | |
220 | exit 1 | |
221 | fi | |
222 | fi | |
223 | if [ ! -f /proc/sys/fs/binfmt_misc/register ]; then | |
224 | if ! mount binfmt_misc -t binfmt_misc /proc/sys/fs/binfmt_misc ; then | |
225 | exit 1 | |
226 | fi | |
227 | fi | |
228 | ||
229 | qemu_check_access /proc/sys/fs/binfmt_misc/register | |
230 | } | |
231 | ||
232 | installed_dpkg() { | |
233 | dpkg --status "$1" > /dev/null 2>&1 | |
234 | } | |
235 | ||
236 | qemu_check_debian() { | |
237 | if [ ! -e /etc/debian_version ] ; then | |
238 | echo "WARNING: your system is not a Debian based distro" 1>&2 | |
239 | elif ! installed_dpkg binfmt-support ; then | |
240 | echo "WARNING: package binfmt-support is needed" 1>&2 | |
241 | fi | |
242 | qemu_check_access "$EXPORTDIR" | |
243 | } | |
244 | ||
245 | qemu_check_systemd() { | |
246 | if ! systemctl -q is-enabled systemd-binfmt.service ; then | |
247 | echo "WARNING: systemd-binfmt.service is missing or disabled" 1>&2 | |
248 | fi | |
249 | qemu_check_access "$EXPORTDIR" | |
250 | } | |
251 | ||
252 | qemu_generate_register() { | |
70a77984 LV |
253 | flags="" |
254 | if [ "$CREDENTIAL" = "yes" ] ; then | |
255 | flags="OC" | |
256 | fi | |
01ecd22a LV |
257 | if [ "$PERSISTENT" = "yes" ] ; then |
258 | flags="${flags}F" | |
259 | fi | |
70a77984 LV |
260 | |
261 | echo ":qemu-$cpu:M::$magic:$mask:$qemu:$flags" | |
3bef0451 LV |
262 | } |
263 | ||
264 | qemu_register_interpreter() { | |
265 | echo "Setting $qemu as binfmt interpreter for $cpu" | |
266 | qemu_generate_register > /proc/sys/fs/binfmt_misc/register | |
267 | } | |
268 | ||
269 | qemu_generate_systemd() { | |
270 | echo "Setting $qemu as binfmt interpreter for $cpu for systemd-binfmt.service" | |
271 | qemu_generate_register > "$EXPORTDIR/qemu-$cpu.conf" | |
272 | } | |
273 | ||
274 | qemu_generate_debian() { | |
275 | cat > "$EXPORTDIR/qemu-$cpu" <<EOF | |
276 | package qemu-$cpu | |
277 | interpreter $qemu | |
278 | magic $magic | |
279 | mask $mask | |
70a77984 | 280 | credential $CREDENTIAL |
3bef0451 | 281 | EOF |
3bef0451 LV |
282 | } |
283 | ||
284 | qemu_set_binfmts() { | |
285 | # probe cpu type | |
286 | host_family=$(qemu_get_family) | |
287 | ||
288 | # register the interpreter for each cpu except for the native one | |
289 | ||
290 | for cpu in ${qemu_target_list} ; do | |
291 | magic=$(eval echo \$${cpu}_magic) | |
292 | mask=$(eval echo \$${cpu}_mask) | |
293 | family=$(eval echo \$${cpu}_family) | |
294 | ||
295 | if [ "$magic" = "" ] || [ "$mask" = "" ] || [ "$family" = "" ] ; then | |
296 | echo "INTERNAL ERROR: unknown cpu $cpu" 1>&2 | |
297 | continue | |
298 | fi | |
299 | ||
300 | qemu="$QEMU_PATH/qemu-$cpu" | |
301 | if [ "$cpu" = "i486" ] ; then | |
302 | qemu="$QEMU_PATH/qemu-i386" | |
303 | fi | |
304 | ||
7155be7c | 305 | qemu="$qemu$QEMU_SUFFIX" |
3bef0451 LV |
306 | if [ "$host_family" != "$family" ] ; then |
307 | $BINFMT_SET | |
308 | fi | |
309 | done | |
310 | } | |
311 | ||
312 | CHECK=qemu_check_bintfmt_misc | |
313 | BINFMT_SET=qemu_register_interpreter | |
314 | ||
315 | SYSTEMDDIR="/etc/binfmt.d" | |
316 | DEBIANDIR="/usr/share/binfmts" | |
317 | ||
318 | QEMU_PATH=/usr/local/bin | |
70a77984 | 319 | CREDENTIAL=no |
01ecd22a | 320 | PERSISTENT=no |
7155be7c | 321 | QEMU_SUFFIX="" |
3bef0451 | 322 | |
7155be7c | 323 | options=$(getopt -o ds:Q:S:e:hc:p: -l debian,systemd:,qemu-path:,qemu-suffix:,exportdir:,help,credential:,persistent: -- "$@") |
3bef0451 LV |
324 | eval set -- "$options" |
325 | ||
326 | while true ; do | |
327 | case "$1" in | |
328 | -d|--debian) | |
329 | CHECK=qemu_check_debian | |
330 | BINFMT_SET=qemu_generate_debian | |
331 | EXPORTDIR=${EXPORTDIR:-$DEBIANDIR} | |
332 | ;; | |
333 | -s|--systemd) | |
334 | CHECK=qemu_check_systemd | |
335 | BINFMT_SET=qemu_generate_systemd | |
336 | EXPORTDIR=${EXPORTDIR:-$SYSTEMDDIR} | |
337 | shift | |
338 | # check given cpu is in the supported CPU list | |
3ff48453 LV |
339 | if [ "$1" != "ALL" ] ; then |
340 | for cpu in ${qemu_target_list} ; do | |
341 | if [ "$cpu" = "$1" ] ; then | |
342 | break | |
343 | fi | |
344 | done | |
345 | ||
6f75023a | 346 | if [ "$cpu" = "$1" ] ; then |
3ff48453 LV |
347 | qemu_target_list="$1" |
348 | else | |
349 | echo "ERROR: unknown CPU \"$1\"" 1>&2 | |
350 | usage | |
351 | exit 1 | |
3bef0451 | 352 | fi |
3bef0451 LV |
353 | fi |
354 | ;; | |
355 | -Q|--qemu-path) | |
356 | shift | |
357 | QEMU_PATH="$1" | |
358 | ;; | |
7155be7c LV |
359 | -F|--qemu-suffix) |
360 | shift | |
361 | QEMU_SUFFIX="$1" | |
362 | ;; | |
3bef0451 LV |
363 | -e|--exportdir) |
364 | shift | |
365 | EXPORTDIR="$1" | |
366 | ;; | |
367 | -h|--help) | |
368 | usage | |
369 | exit 1 | |
370 | ;; | |
371 | -c|--credential) | |
372 | shift | |
70a77984 | 373 | CREDENTIAL="$1" |
3bef0451 | 374 | ;; |
01ecd22a LV |
375 | -p|--persistent) |
376 | shift | |
377 | PERSISTENT="$1" | |
3bef0451 LV |
378 | ;; |
379 | *) | |
380 | break | |
381 | ;; | |
382 | esac | |
383 | shift | |
384 | done | |
385 | ||
386 | $CHECK | |
387 | qemu_set_binfmts |